/*
 * gtkDPS paint selection test program by Masatake YAMATO
 */

#include <stdio.h>
#include "gtkDPSlinesel.h"
#include "gtkDPS.h"
#include <gtk/gtk.h>

static void init_gui (int argc, char *argv[]);

int 
main(int argc, char *argv[])
{
  const gchar * version;
  gtk_set_locale();
  gtk_init (&argc, &argv);
  gtk_dps_init (&argc, &argv);
  version = gtk_dps_version();
  fprintf(stderr, "GtkDPS version %s\n", version);
  init_gui(argc, argv);
  gtk_main();
  return 0;
}

static void
init_gui (int argc, char *argv[])
{
  GtkWidget * window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  GtkWidget * linesel = gtk_dps_line_selection_new();
  
  gtk_widget_show(linesel);
  gtk_container_add(GTK_CONTAINER(window), linesel);
  gtk_widget_show(window);
  gtk_signal_connect (GTK_OBJECT (window), "destroy",
		      GTK_SIGNAL_FUNC (gtk_exit), NULL);
  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		      GTK_SIGNAL_FUNC (gtk_exit), NULL);
}
